#!/usr/local/bin/env node

var program = require("commander"),
    util = require("util"),
    epub3 = require("./lib");


program
    .version("0.0.1")
    .option('-c, --create email [directory]', "Create Epub3 Scarfold.")
    .option('-v, --validate     [directory]', "Validate Epub Directory. Uses CWD if no directory is supplied.")
    .option('-a, --archive      [directory]', "Creates an Epub Archive")
    .parse(process.argv);

if (program.create) {
    var email = program.create,
        workspace = program.dir;

    epub3.create(email, workspace, function (result) {
        console.log(result)
    });
}
else if (program.validate) {
    epub3.validate();
}
else{
    console.log("Invalid Arguments");
    program.help();
}